<!DOCTYPE html>
<!--
    1.  HTML 태그를 반복해서 표시하고자 사용하는 것이 v-for 디렉티브입니다.
                배열 데이터나 반복 표시 또는 횟수를 지정해서 반복 표시하도록 만들 수 있습니다.
    2.  형식)
        (1) <태그명 v-for="변수 in 최대값"> 반복 부분 </태그명>
            숫자가 1부터 최대값까지 1씩 증가합니다.

        (2) <태그명 v-for="변수 in 배열"> 반복 부분 </태그명 >
            배열에서 하나씩 꺼내 변수에 담습니다.

        (3) <태그명 v-for="(변수,인덱스) in 배열"> 반복 부분 </태그명>
            인덱스는 0부터 시작

    3. v-key
        (1)  v-bind:key directive를 사용하라는 에러 메시지가 나타납니다.
        (Elements in iteration expect to have 'v-bind:key' directives
        vue/require-v-for-key)

        (2) https://kr.vuejs.org/v2/guide/list.html#v-for-와-컴포넌트
        2.2.0 이상에서 v-for는 key 가 필수 입니다

    (3)https://kr.vuejs.org/v2/guide/list.html?#Maintaining-State
        Vue에서 개별 DOM 노드들을 추적하고 기존 엘리먼트를 재사용,
        재정렬하기 위해서 v-for의 각 항목들에 고유한 key 속성을 제공해야 합니다.
        key에 대한 이상적인 값은 각 항목을 식별할 수 있는 고유한 ID입니다.
        문자열이나 숫자를 사용하세요.
-->

<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
</head>
<body>
    <div id="app">
        <h2>배열 반복</h2>
        <div v-for="(item, index) in people" :key="index">{{`${index}: ${item.age}살 ${item.name}`}}</div>
        <hr>

        <h2>객체 속성 반복</h2>
        <div v-for="(value, name, index) in user" :key="index">{{`${index}: ${name}: ${value}`}}</div>
        <hr>

        <h2>Range 반복</h2>
        <div v-for="n in 10" :key="n">{{`${n}`}}</div>
        <hr>

        <!--
        v-for과 v-if를 한 엘리먼트에 동시에 사용하지 말자.
        v-for이 우선순위가 높아서 v-if가 false여도 반복문이 돌아간다고 한다.
        동시에 써야하는 경우에는 부모 엘리먼트를 하나 두고 거기에 v-if를 설정하자.

        일부만 반복하고 싶은 경우 compute나 methods를 사용해서 배열의 일부만 구하는 식으로 v-for문을 돌려야 한다.
        -->
    </div>

    <script>
        new Vue({
            el: "#app",
            data: {
                people: [
                    {name: '홍길동', age: 30},
                    {name: '정해인', age: 25},
                    {name: '박형식', age: 20},
                ],
                user: {
                    name: '홍길동',
                    age: 30,
                }
            },
        });
    </script>
</body>
</html>